<template>
	<view>
		<view class="block">
			<view class="content">
				<view class="my">
					我的账户余额： {{user.gold || 0}} 个 ( 1:100)
				</view>
			</view>
		</view>
		<view class="block">
			<view class="title">
				充值金额
			</view>
			<view class="content">
				<view class="amount">
					<view class="list">
						<view class="box" v-for="(amount,index) in amountList" :key="index" @tap="select(amount)"
							:class="{'on':amount == inputAmount}">
							<view class="heTitle">{{amount}}元</view>
							<view class="font14">{{amount * 100}}分</view>
						</view>
					</view>
					<view class="num">
						<view class="text font13">
							自定义充值金额(兑:{{inputAmount * 100}}分)
						</view>
						<view class="input">
							<input type="number" v-model="inputAmount" />
						</view>
					</view>
				</view>
			</view>
		</view>
		<view class="block">
			<view class="title">
				选择支付方式
			</view>
			<view class="content">
				<view class="pay-list" v-for="(item,index) in paytypeList" :key="index">
					<view class="row" @tap="paytype='2'" v-if="item == 2">
						<view class="left">
							<image :src="imagewxUrl+imgadres"></image>
						</view>
						<view class="center">
							微信支付
						</view>
						<view class="right">
							<radio :checked="paytype=='2'" color="#0083f5" />
						</view>
					</view>
				</view>
			</view>
		</view>
		<view class="pay">
			<button class="btn" @tap="doDeposit">立即充值</button>
			<view class="tis">
				点击立即充值，即代表您同意<view class="terms">
					《条款协议》
				</view>
			</view>
		</view>
	</view>
</template>

<script>
	let app = getApp()
	import {
		create,
		wechatPay,
		getThirdPartyByDetail,
		findUser,
	} from "../../../Utils/Api.js";
	// #ifdef H5
	var jweixin = require('jweixin-module');
	// #endif
	export default {
		data() {
			return {
				inputAmount: '', //金额
				amountList: [100, 200, 300, 500, 800, 1000], //预设3个可选快捷金额
				paytype: '2', //支付类型
				user: "",
				imagewxUrl: app.globalData.imageWxImg,
				imgadres: 'wxpay.png',
				paytypeList: [], //支付方式
				isGoBack:false,
			};
		},
		onLoad(options) {
			// console.log(options)
			if(options.inputAmount){
				this.inputAmount=options.inputAmount;
				this.isGoBack = true;
			}
			
			
			this.findUser();
			
			
			
		},
		onShow() {
			this.getThirdPartyByDetail();
			if(app.globalData.userInfo){
				this.findUser();
			}
			
			console.log(this.user,"user")
		},
		methods: {
			//查询我的信息接口
			findUser() {
				findUser().then(res => {
					if (res.return_code == '000000') {
						app.globalData.userInfo = res.return_data;
						this.user = res.return_data;
						uni.setStorage({
							key: "user",
							data: res.return_data
						})
					}
				});
			},
			//查询支付方式
			getThirdPartyByDetail() {
				// #ifdef H5
				this.showType = 2;
				// #endif
				// #ifdef MP
				this.showType = 1;
				// #endif
				let datas = {
					platformId: this.showType,
					"companyId": app.globalData.companyId,
					productType: 4
				}
				getThirdPartyByDetail(datas).then(res => {
					if (res.return_code == '000000') {
						this.paytypeList = res.return_data.productPayType.split(',');
						this.paytypeList = this.paytypeList.slice(0, this.paytypeList.length - 1);
					}
				});
			},
			select(amount) {
				this.inputAmount = amount;
			},
			doDeposit() {
				if (parseFloat(this.inputAmount).toString() == "NaN") {
					uni.showToast({
						title: '请输入正确金额',
						icon: 'none'
					});
					return;
				}
				if (this.inputAmount <= 0) {
					uni.showToast({
						title: '请输入大于0的金额',
						icon: 'none'
					});
					return;
				}
				if (parseFloat(this.inputAmount).toFixed(2) != parseFloat(this.inputAmount)) {
					uni.showToast({
						title: '最多只能输入两位小数哦~',
						icon: 'none'
					});
					return;
				}
				uni.showLoading({
					title: '正在提交订单...'
				})
				let goods = {
					"childOrderList": [{
						"goodsId": app.globalData.userInfo.id,
						"goodsPrice": this.inputAmount,
						"goodsType": 2,
						"saleCount": 1,
					}],
					"promoteCode": app.globalData.identificationCode,
					"companyId": app.globalData.companyId
				}

				create(goods).then(res => {
					uni.hideLoading();
					if (res.return_code == '000000') {
						//模板模拟支付，实际应用请调起微信/支付宝
						// #ifdef H5
						let params = {
							"orderNo": res.return_data.orderNo,
							"openId": app.globalData.openId,
							"openIdType": 2
						}
						// #endif
						// #ifdef MP
						let params = {
							"orderNo": res.return_data.orderNo,
							"openId": app.globalData.openId,
							"openIdType": 1
						}
						// #endif
						wechatPay(params).then(res => {
							if (res.return_code == '000000') {
								// #ifdef MP
								uni.showLoading({
									title: '支付中...'
								})
								uni.requestPayment({
									"appId": res.return_data.appId,
									"nonceStr": res.return_data.nonceStr,
									"package": res.return_data.package,
									"paySign": res.return_data.sign,
									"signType": "MD5",
									"timeStamp": res.return_data.timeStamp,
									success: function(res) {
										uni.hideLoading();
										uni.showToast({
											title: '支付成功'
										})
										setTimeout(() => {
											uni.navigateBack({})
										}, 100)
									},
									fail: function(err) {
										uni.hideLoading();
										console.log('fail:' + JSON.stringify(err));
									}
								});
								// #endif

								//判断是否是公众号
								// #ifdef H5
								//判断微信浏览器
								this.payRequest(res);
								// #endif
							} else {
								uni.showToast({
									title: '支付失败',
									duration:2000,
									icon:"none"
								})
							}
						})


					} else {
						uni.showToast({
							title: res.return_msg,
							duration: 2000,
							icon: 'none'
						});
					}
				})
			},
			payRequest: function(self) {
				let that = this;
				uni.showLoading({
					title: '支付中...'
				})
				jweixin.config({
					// debug: true, // 开启调试模式,调用的所有api的返回值会在客户端alert出来，若要查看传入的参数，可以在pc端打开，参数信息会通过log打出，仅在pc端时才会打印。
					appId: self.return_data.appId, // 必填，公众号的唯一标识
					timestamp: self.return_data.timeStamp, // 必填，生成签名的时间戳
					nonceStr: self.return_data.nonceStr, // 必填，生成签名的随机串
					signature: self.return_data.sign, // 必填，签名，见附录1
					jsApiList: ['chooseWXPay'] // 必填，需要使用的JS接口列表，所有JS接口列表见附录2
				});
				uni.hideLoading();
				jweixin.ready(function() {
					jweixin.checkJsApi({
						jsApiList: ['chooseWXPay'], // 需要检测的JS接口列表，所有JS接口列表见附录2,
						success: function(res) {},
						fail: function(res) {}
					});
					jweixin.chooseWXPay({
						appId: self.return_data.appId,
						timestamp: self.return_data
							.timeStamp, // 支付签名时间戳，注意微信jssdk中的所有使用timestamp字段均为小写。但最新版的支付后台生成签名使用的timeStamp字段名需大写其中的S字符
						nonceStr: self.return_data.nonceStr, // 支付签名随机串，不长于 32 位
						package: self.return_data
							.package, // 统一支付接口返回的prepay_id参数值，提交格式如：prepay_id=***）
						signType: 'MD5', // 签名方式，默认为'SHA1'，使用新版支付需传入'MD5'
						paySign: self.return_data.sign, // 支付签名
						success: function(res) {
							// 支付成功后的回调函数
							uni.showToast({
								title: '支付成功'
							})
							
							if(that.isGoBack){
								setTimeout(() => {
									uni.navigateBack({})
								}, 100)
							}else{
								uni.reLaunch({
									url: '../success/success?id=' + that.couponId
								});
							}
						},
						cancel: function(r) {},
						fail: function(res) {}
					});
				});

				jweixin.error(function(res) {
					uni.showToast({
						icon: 'none',
						title: '支付失败了',
						duration: 4000
					});
				});
			},
		},

	}
</script>

<style lang="scss">
	.block {
		width: 94%;
		padding: 20upx 3%;

		.title {
			width: 100%;
			font-size: 34upx;
		}

		.content {
			.my {
				width: 100%;
				height: 120upx;
				display: flex;
				align-items: center;
				font-size: 30upx;
				border-bottom: solid 1upx #eee;
			}

			.amount {
				width: 100%;


				.list {
					width: 94%;
					margin-left: 3%;
					display: flow-root;
					justify-content: space-between;
					align-items: center;
					padding: 20upx 0;

					.box {
						width: 30%;
						margin-left: 1%;
						margin-right: 2%;
						margin-top: 20upx;
						float: left;
						height: 120upx;
						// line-height: 120upx;
						display: inline-grid;
						justify-content: center;
						align-items: center;
						text-align: center;
						box-shadow: 0upx 0upx 4upx #666666;
						font-size: 36upx;
						color: #089bf5;
						background-color: #f1f1f1;

						&.on {
							background-color: #089bf5;
							color: #ffffff;
						}
					}

					.heTitle {
						width: 100%;
						font-size: 15px;
					}
				}

				// .list {
				// 	display: flow-root;
				// 	justify-content: space-between;
				// 	padding: 20upx 0;

				// 	.box {
				// 		width: 30%;
				// 		height: 120rpx;
				// 		float: left;
				// 		margin-left: 3.333%;
				// 		margin-top: 20px;
				// 		display: flex;
				// 		justify-content: center;
				// 		align-items: center;
				// 		border-radius: 10rpx;
				// 		box-shadow: 0rpx 5rpx 20rpx rgba(0, 0, 0, 0.05);
				// 		font-size: 36rpx;
				// 		background-color: #f1f1f1;
				// 		color: 333;

				// 		&.on {
				// 			background-color: #0083f5;
				// 			color: #fff;
				// 		}
				// 	}
				// 	.heTitle {
				// 		width: 100%;
				// 		font-size: 15px;
				// 	}
				// }

				.num {
					margin-top: 20upx;
					display: flex;
					justify-content: flex-end;
					align-items: center;

					.text {
						padding-right: 10upx;
					}

					.input {
						width: 28.2vw;
						border-bottom: solid 2upx #999;

						justify-content: flex-end;
						align-items: center;

						input {
							margin: 0 20upx;
							height: 60upx;
							font-size: 40upx;
							color: #0083f5;
							justify-content: flex-end;
							align-items: center;
						}
					}
				}
			}

			.pay-list {
				width: 100%;
				border-bottom: solid 1upx #eee;

				.row {
					width: 100%;
					height: 120upx;
					display: flex;
					align-items: center;

					.left {
						width: 100upx;
						flex-shrink: 0;
						display: flex;
						align-items: center;

						image {
							width: 80upx;
							height: 80upx;
						}
					}

					.center {
						width: 100%;
						font-size: 30upx;
					}

					.right {
						width: 100upx;
						flex-shrink: 0;
						display: flex;
						justify-content: flex-end;
					}
				}
			}
		}
	}

	.pay {
		margin-top: 20upx;
		width: 100%;
		display: flex;
		justify-content: center;
		flex-wrap: wrap;

		.btn {
			width: 70%;
			height: 80upx;
			border-radius: 80upx;
			display: flex;
			justify-content: center;
			align-items: center;
			color: #fff;
			background-color: #0083f5;
			box-shadow: 0upx 5upx 10upx rgba(0, 0, 0, 0.2);
		}

		.tis {
			margin-top: 10upx;
			width: 100%;
			font-size: 24upx;
			display: flex;
			justify-content: center;
			align-items: baseline;
			color: #999;

			.terms {
				color: #5a9ef7;
			}
		}
	}
</style>
